<bugID>1353725<Summary>displaying the awesomebar panel could be smoother</Summary><Description>Created attachment 8854850
Screencast on fast macbook

The attached screencast is to be played frame by frame. It was recorded on a very fast latest generation macbook. What requires a slow frame by frame replay here will likely be user-noticeable on a low-end machine.

On the first frame where the panel is visible, we have only one item shown, and there's more whitespace before it than there should be.

On the next frame, the blue (i) icon and the settings gear icon appear.

2 frames later, the aligment issue is fixed (but moving this text to the left while it's already visible on screen causes perceived flickering), a second item (from the bookmarks) appears, and the first item gets selected.

On the next frame, a second result from bookmarks appears. 2 frames later, I have 2 more items displayed, and the globe icon appears in the first selected item.

3 more frames later, I have more items that appear. I think they are from the prepopulated history (eg. youtube, facebook, ...).

On the next frame, the favicons and the star bookmark icon appear for the 5 items that are results coming from the bookmarks.


When I typed the second letter ("l"), the first item changes to "bl - Search with Google". It doesn't have an icon. The search glass icon appears on the next frame.

2 frames later, the content of the third item is copied over the second item (so it's duplicated).

16 (!) frames later, all the following results disappear and the panel shrinks.


I'm filing this bug mostly to start investigating what should be done here, we may decide to turn this into a meta bug at some point.

I think there are a few things that we could do better here:
- display the first item at the right position immediately (likely bug 1353563)
- select the first item immediately (likely bug 1353708)
- somehow preload the icons we are sure we'll need, so that the globe icon, bookmark star, search glass and gear icon appear immediately.
- if we can't shrink the panel faster, hide the obsolete items as soon as we start displaying a new item.

I think a lot of the broken intermediate frames we display can be attributed to excessive sync layout flushes we do while displaying the panel, so I'm making this depend on bug 1353563 and bug 1353708.</Description></bugID>